Loading...
Searching...
No Matches
juce::PixelAlpha Class Reference

## Detailed Description

Represents an 8-bit single-channel pixel, and can perform compositing operations on it.

This is used internally by the imaging classes.

See also
  PixelARGB, PixelRGB

The documentation for this class was generated from the following file:

- juce_graphics/colour/juce_PixelFormats.h

## Public Types

enum | { indexA = 0 }
| The indexes of the different components in the byte layout of this type of colour. More...

## Public Member Functions

| PixelAlpha () noexcept=default
| Creates a pixel without defining its colour.
forcedinline uint32 | getNativeARGB () const noexcept
| Returns a uint32 which represents the pixel in a platform dependent format which is compatible with the native format of a PixelARGB.
forcedinline uint32 | getInARGBMaskOrder () const noexcept
| Returns a uint32 which will be in argb order as if constructed with the following mask operation ((alpha << 24) | (red << 16) | (green << 8) | blue).
uint32 | getInARGBMemoryOrder () const noexcept
| Returns a uint32 which when written to memory, will be in the order a, r, g, b.
forcedinline uint32 | getEvenBytes () const noexcept
| Return channels with an even index and insert zero bytes between them.
forcedinline uint32 | getOddBytes () const noexcept
| Return channels with an odd index and insert zero bytes between them.
forcedinline uint8 | getAlpha () const noexcept
forcedinline uint8 | getRed () const noexcept
forcedinline uint8 | getGreen () const noexcept
forcedinline uint8 | getBlue () const noexcept
template<class Pixel>
forcedinline void | set (const Pixel &src) noexcept
| Copies another pixel colour over this one.
forcedinline void | setARGB (uint8 a_, uint8, uint8, uint8) noexcept
| Sets the pixel's colour from individual components.
template<class Pixel>
forcedinline void | blend (const Pixel &src) noexcept
| Blends another pixel onto this one.
template<class Pixel>
forcedinline void | blend (const Pixel &src, uint32 extraAlpha) noexcept
| Blends another pixel onto this one, applying an extra multiplier to its opacity.
template<class Pixel>
forcedinline void | tween (const Pixel &src, uint32 amount) noexcept
| Blends another pixel with this one, creating a colour that is somewhere between the two, as specified by the amount.
forcedinline void | setAlpha (uint8 newAlpha) noexcept
| Replaces the colour's alpha value with another one.
forcedinline void | multiplyAlpha (int multiplier) noexcept
| Multiplies the colour's alpha value with another one.
forcedinline void | multiplyAlpha (float multiplier) noexcept
forcedinline void | premultiply () noexcept
| Premultiplies the pixel's RGB values by its alpha.
forcedinline void | unpremultiply () noexcept
| Unpremultiplies the pixel's RGB values.
forcedinline void | desaturate () noexcept

## Member Enums

## anonymous enum

anonymous enum

The indexes of the different components in the byte layout of this type of colour.

Enumerator
indexA |

## Constructors and Destructors

## PixelAlpha()

juce::PixelAlpha::PixelAlpha | ( |  | ) |

default noexcept

Creates a pixel without defining its colour.

## Member Functions

## getNativeARGB()

forcedinline uint32 juce::PixelAlpha::getNativeARGB | ( |  | ) | const

inline noexcept

Returns a uint32 which represents the pixel in a platform dependent format which is compatible with the native format of a PixelARGB.

See also
  PixelARGB::getNativeARGB

References forcedinline, and getNativeARGB().

Referenced by getInARGBMaskOrder(), getInARGBMemoryOrder(), and getNativeARGB().

## getInARGBMaskOrder()

forcedinline uint32 juce::PixelAlpha::getInARGBMaskOrder | ( |  | ) | const

inline noexcept

Returns a uint32 which will be in argb order as if constructed with the following mask operation ((alpha << 24) | (red << 16) | (green << 8) | blue).

References forcedinline, and getNativeARGB().

## getInARGBMemoryOrder()

uint32 juce::PixelAlpha::getInARGBMemoryOrder | ( |  | ) | const

inline noexcept

Returns a uint32 which when written to memory, will be in the order a, r, g, b.

In other words, if the return-value is read as a uint8 array then the elements will be in the order of a, r, g, b

References getNativeARGB().

## getEvenBytes()

forcedinline uint32 juce::PixelAlpha::getEvenBytes | ( |  | ) | const

inline noexcept

Return channels with an even index and insert zero bytes between them.

This is useful for blending operations. The exact channels which are returned is platform dependent but compatible with the return value of getEvenBytes of the PixelARGB class.

See also
  PixelARGB::getEvenBytes

References forcedinline.

## getOddBytes()

forcedinline uint32 juce::PixelAlpha::getOddBytes | ( |  | ) | const

inline noexcept

Return channels with an odd index and insert zero bytes between them.

This is useful for blending operations. The exact channels which are returned is platform dependent but compatible with the return value of getOddBytes of the PixelARGB class.

See also
  PixelARGB::getOddBytes

References forcedinline.

## getAlpha()

forcedinline uint8 juce::PixelAlpha::getAlpha | ( |  | ) | const

inline noexcept

References forcedinline.

## getRed()

forcedinline uint8 juce::PixelAlpha::getRed | ( |  | ) | const

inline noexcept

References forcedinline.

## getGreen()

forcedinline uint8 juce::PixelAlpha::getGreen | ( |  | ) | const

inline noexcept

References forcedinline.

## getBlue()

forcedinline uint8 juce::PixelAlpha::getBlue | ( |  | ) | const

inline noexcept

References forcedinline.

## set()

template<class Pixel>

forcedinline void juce::PixelAlpha::set | ( | const Pixel & | src | ) |

inline noexcept

Copies another pixel colour over this one.

This doesn't blend it - this colour is simply replaced by the other one.

References forcedinline.

## setARGB()

forcedinline void juce::PixelAlpha::setARGB | ( | uint8 | a_,
|  | uint8 | ,
|  | uint8 | ,
|  | uint8 | )

inline noexcept

Sets the pixel's colour from individual components.

References forcedinline.

## blend() [1/2]

template<class Pixel>

forcedinline void juce::PixelAlpha::blend | ( | const Pixel & | src | ) |

inline noexcept

Blends another pixel onto this one.

This takes into account the opacity of the pixel being overlaid, and blends it accordingly.

References forcedinline.

## blend() [2/2]

template<class Pixel>

forcedinline void juce::PixelAlpha::blend | ( | const Pixel & | src,
|  | uint32 | extraAlpha )

inline noexcept

Blends another pixel onto this one, applying an extra multiplier to its opacity.

The opacity of the pixel being overlaid is scaled by the extraAlpha factor before being used, so this can blend semi-transparently from a PixelRGB argument.

References forcedinline.

## tween()

template<class Pixel>

forcedinline void juce::PixelAlpha::tween | ( | const Pixel & | src,
|  | uint32 | amount )

inline noexcept

Blends another pixel with this one, creating a colour that is somewhere between the two, as specified by the amount.

References forcedinline.

## setAlpha()

forcedinline void juce::PixelAlpha::setAlpha | ( | uint8 | newAlpha | ) |

inline noexcept

Replaces the colour's alpha value with another one.

References forcedinline.

## multiplyAlpha() [1/2]

forcedinline void juce::PixelAlpha::multiplyAlpha | ( | int | multiplier | ) |

inline noexcept

Multiplies the colour's alpha value with another one.

References forcedinline.

## multiplyAlpha() [2/2]

forcedinline void juce::PixelAlpha::multiplyAlpha | ( | float | multiplier | ) |

inline noexcept

References forcedinline.

## premultiply()

forcedinline void juce::PixelAlpha::premultiply | ( |  | ) |

inline noexcept

Premultiplies the pixel's RGB values by its alpha.

References forcedinline.

## unpremultiply()

forcedinline void juce::PixelAlpha::unpremultiply | ( |  | ) |

inline noexcept

Unpremultiplies the pixel's RGB values.

References forcedinline.

## desaturate()

forcedinline void juce::PixelAlpha::desaturate | ( |  | ) |

inline noexcept

References forcedinline.

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited